package com.yhy.module.core.enums.infoprice;

import cn.hutool.core.util.ArrayUtil;
import cn.iocoder.yudao.framework.common.core.ArrayValuable;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.Arrays;

/**
 * 信息价分类树节点类型枚举
 *
 * @author 芋道源码
 */
@Getter
@AllArgsConstructor
public enum InfoPriceCategoryNodeTypeEnum implements ArrayValuable<Integer> {

    DIRECTORY(1, "目录", "可以添加子目录和内容节点"),
    CONTENT(2, "内容", "只能添加工料机信息，不能添加子节点");

    public static final Integer[] ARRAYS = Arrays.stream(values()).map(InfoPriceCategoryNodeTypeEnum::getType).toArray(Integer[]::new);

    /**
     * 类型
     */
    private final Integer type;
    /**
     * 名称
     */
    private final String name;
    /**
     * 描述
     */
    private final String description;

    @Override
    public Integer[] array() {
        return ARRAYS;
    }

    public static InfoPriceCategoryNodeTypeEnum valueOfType(Integer type) {
        return ArrayUtil.firstMatch(o -> o.getType().equals(type), values());
    }
}
